<template>
  <v-form
    ref="form"
    class="w-form"
    @submit.prevent="submit"
    v-model="isValidForm"
  >
    <v-text-field
      ref="field"
      class="w-form__field"
      :label="$t('fieldLabel')"
      :rules="fieldRules"
      v-model="searchQuery"
      clearable
      @input="$emit('clear-errors')"
    />
    {{!-- REVIEW v-t ??? --}}
    <v-btn
      :disabled="!isValidForm"
      type="submit"
      class="w-form__submit"
      outlined
      color="indigo"
      small
      v-t="'btnText'"
    />
  </v-form>
</template>

<script>
import messages from "@/locales/w-form";

export default {
  name: "WForm",
  props: {
    emptyCity: Boolean,
    availableCity: Boolean,
  },
  data() {
    return {
      searchQuery: "",
      isValidForm: false,
    };
  },
  created() {
    this.fieldRules = [
      (v) => !!v || this.$t("requiredRule"),
      () => !this.emptyCity || this.$t("emptyCityRule"),
      () => !this.availableCity || this.$t("availableCityRule"),
    ];
  },
  i18n: {
    messages,
  },
  watch: {
    "$i18n.locale"() {
      // TODO: тут ничего лучшего в голову не пришло для обновления ошибок формы.
      this.validate();
    },
  },
  methods: {
    submit() {
      if (!this.isValidForm) {
        return;
      }

      this.$emit("submit", { query: this.searchQuery });
    },

    async validate() {
      if (!this.$refs.field.isDirty) {
        return;
      }

      await this.$nextTick();
      this.$refs.form.validate();
    },

    resetForm() {
      this.$refs.form.reset();
    },

    fillFormField(query) {
      this.searchQuery = query;
    },
  },
};
</script>

<style lang="scss">
.w-form {
  display: flex;
  align-items: center;
  align-self: center;
  max-width: 320px;
  width: 100%;

  &__field {
    width: 100%;
    margin: 0 24px 0 0;
  }
}
</style>
